<?php
// +-----------------------------------------------------------------------+
// | Mod Name : Download_multi                                             |
// | Mod Version : 0.7.1                                                   |
// | Mod Orignal author: Tboris                                            |
// | Mod Second author : Cestlodovic                                       |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Ce module est bas sur le module existant pour le tlchargement,     |
// | cette version permet le tlchargement sur plusieurs pages.           |
// | Mod Addon : PclZip -> http://www.phpconcept.net/pclzip/               |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

//--------------------------------------------------------------------- include
define('PHPWG_ROOT_PATH', '../../');
include_once(PHPWG_ROOT_PATH.'include/common.inc.php');

$title = ' Download Multi';
include( PHPWG_ROOT_PATH.'include/page_header.php' );

$page['section'] = '';
include(PHPWG_ROOT_PATH.'include/menubar.inc.php');

$template->set_filenames( array('panier'=>PHPWG_ROOT_PATH.'modules/download_multi/template/panier.tpl') );
  
include_once( PHPWG_ROOT_PATH.'modules/download_multi/include/function.inc.php' );
@$src = $_GET['src']; // Etat utilis pour le rechargement de la liste des fichiers tlchargeable
@$prefix = $_POST['nom']; // Prfixe des fichiers zip. 

// +-----------------------------------------------------------------------+
// |                                 action                                |
// +-----------------------------------------------------------------------+
// Rpertoire de l'utilisateur
$dir_zip = dirname ($_SERVER["SCRIPT_FILENAME"]).'/zip_archive/'.$user['id'].'/';

$template->assign_block_vars(
    'telechargement',
        array(
            'URL_HOME' => duplicate_index_URL(),
            'U_HELP' => PHPWG_ROOT_PATH.'popuphelp.php?page=download_multi',
        ));
  
// Si l'utilisateur vient de la page thumbnail
// il lui est demander de saisir un nom pour
// la gnration des fichiers zip
if($src == 'name')
{
	$template->assign_block_vars('telechargement.name', 
        array(
            'VALUE' => $conf['mod_dl_multi_prefix'],
            'F_ACTION' => 'panier.php?src=',
    ));
}
else
{  
    // Si la page est recharg par le bouton "Supprimer"
    // du formulaire il ne faut pas recrer les fichiers
    if ($src != 'reload')
    {
        // Slection des photos par rapport  l'id utilisateur
        $query = '
            SELECT id_image, filesize, type FROM '.MOD_DOWNLOAD_MULTI.'
            WHERE id_user = '.$user['id'].'
        ;';
        $result = pwg_query($query);
        
        // Si aucun prfix n'est envoy
        // il est automatiquement attribu a
        // la valeur par dfaut dfinit dans include/config_local.inc.php
        if ($prefix == '')
        {
            $prefix = $conf['mod_dl_multi_prefix'];
        }
        else
        {
            // Contrle les caractres spciaux
            // et les remplaces par un valeur correcte
            $accents = "ABCDEFGHIJKLMNOPQRSTUVWXYZ :,.;?!~'()/&%*\"$[]{}|";
            $ssaccents = "abcdefghijklmnopqrstuvwxyzAAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn_______________________";
            $prefix = strtr( $prefix, $accents, $ssaccents ); 
        }
             
        // Si le nombre d'enregistrement est gale 
        // 0, alors il n'y a pas de fichier propos au tlchargement
        if (mysql_num_rows($result) != 0)
        {
            require('include/pclzip.lib.php'); // inclusion de la librairie pour la compression zip
            $id_file = rand(1, 2000);
            $nom_fichier = $prefix.$id_file.'.zip'; // nom du fichier zip
            $fichier_zip = $dir_zip.$nom_fichier; // chemin d'accs au fichier zip
            $archive = new PclZip($fichier_zip);
            $fic_size = 0; // Initialisation de la taille

            while ($row = mysql_fetch_array($result))
            {
                // Slection des informations ncessaire pour 
                // gnrer le fichier zip
                $query_1 = '
                    SELECT file, path
                    FROM '.IMAGES_TABLE.'
                    WHERE id = \''.$row['id_image'].'\'
                ;';
                $row_1 = mysql_fetch_array(pwg_query($query_1));
                
                if($row['type'] == 't')
                {
                    // A INTEGRER DANS LA PROCHAINE VERSION
                    $fic_insert = dirname('../.'.$row_1['path']).'/thumbnail/'.$conf['prefix_thumbnail'].$row_1['file'];
                }
                if($row['type'] == 'n')
                {
                    $fic_insert = dirname('../.'.$row_1['path']).'/'.$row_1['file'];  
                }
                if($row['type'] == 'h')
                {
                    $fic_insert = dirname('../.'.$row_1['path']).'/pwg_high/'.$row_1['file'];  
                }                       
               
                // Taille de l'archive
                // si l'archive est plus petite que la valeur dfinit
                // le mme fichier est utilis
                if ( $fic_size < $conf['mod_dl_multi_archive_size'] )
                {
                    if( $conf['mod_dl_multi_comment_activate'] )
                    {
                        $v_list = $archive->add($fic_insert,
                                                PCLZIP_OPT_REMOVE_PATH, '../../galleries',
                                                PCLZIP_OPT_ADD_PATH, $conf['mod_dl_multi_prefix_dir'],
                                                PCLZIP_OPT_COMMENT, $conf['mod_dl_multi_comment']
                                              );
                    }
                    else
                    {
                        $v_list = $archive->add($fic_insert,
                                                PCLZIP_OPT_REMOVE_PATH, '../../galleries',
                                                PCLZIP_OPT_ADD_PATH, $conf['mod_dl_multi_prefix_dir']
                                              );
                    }
                    if ($v_list == 0)
                    {
                        die('Erreur : '.$archive->errorInfo(true));
                    }                                            
                }
                // Si l'archive est plus grande que la valeur dfinit
                // un nouveau fichier est cr.
                else
                {
                    $id_file = rand(1, 2000);
                    $nom_fichier = $prefix.$id_file.'.zip'; // nom du fichier zip
                    $fichier_zip = $dir_zip.$nom_fichier; // chemin d'accs au fichier zip
                    $archive = new PclZip($fichier_zip);
                    $fic_size = 0; // Initialisation de la taille
                    if( $conf['mod_dl_multi_comment_activate'] )
                    {
                        $v_list = $archive->add($fic_insert,
                                                PCLZIP_OPT_REMOVE_PATH, '../../galleries',
                                                PCLZIP_OPT_ADD_PATH, $conf['mod_dl_multi_prefix_dir'],
                                                PCLZIP_OPT_COMMENT, $conf['mod_dl_multi_comment']
                                              );
                    }
                    else
                    {
                        $v_list = $archive->add($fic_insert,
                                                PCLZIP_OPT_REMOVE_PATH, '../../galleries',
                                                PCLZIP_OPT_ADD_PATH, $conf['mod_dl_multi_prefix_dir']
                                              );
                    }
                    if ($v_list == 0)
                    {
                        die('Erreur : '.$archive->errorInfo(true));
                    }
                }
                $fic_size = $row['filesize'] + $fic_size;
            }
        } 
    }

    // Liste le rpertoire de l'utlilisateur
    list_dir($dir_zip);
    clearstatcache();
}

$template->parse('panier');
include( PHPWG_ROOT_PATH.'include/page_tail.php' );
?>
